
Ruby - Bug #12680

Please backport memory leak fixes in ext/openssl

08/16/2016 08:43 AM - rhenium (Kazuki Yamaguchi)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.1: UNKNOWN, 2.2: REQUIRED, 2.3:

DONE

Description

The following methods have an issue of memory leak:

OpenSSL::X509::ExtensionFactory#create_ext

OpenSSL::X509::ExtensionFactory#config=

OpenSSL::X509::Extension#oid=

OpenSSL::X509::Extension#value=

OpenSSL::X509::Attribute#oid=

OpenSSL::X509::Request#set_attributes, #add_attribute

OpenSSL::X509::Revoked#set_extensions, #add_extension

OpenSSL::PKCS12.create

OpenSSL::PKey::EC#export

OpenSSL::PKCS7#verify

OpenSSL::PKCS7#add_data

They are fixed on GitHub ruby/openssl but they all exist in stable branches.

Here are the fixing commits:

https://github.com/ruby/openssl/compare/3a2840e80d275895523a526ce56e4f6e7b8f9cc4...1e30cd395b14ef46e04bdd9ab72f10067

890b265

Or please use the attached patch that applies on top of ruby_2_3 branch if preferred.

Associated revisions

Revision ea5e22d102a357114846874c2ff641f4a18dbdf1 - 08/26/2016 06:48 PM - nagachika (Tomoyuki Chikanaga)

backport fix memory leak from upstream.

https://github.com/ruby/openssl/compare/3a2840e80d275895523a526ce56e4f6e7b8f9cc4...1e30cd395b14ef46e04bdd9ab72f10067890b265

patches are provided by rhe (Kazuki Yamaguchi).

ext/openssl/ossl_config.c: fix memory leak.  [ruby-core:76922] [Bug #12680]

ext/openssl/ossl_ocsp.c: ditto.

ext/openssl/ossl_pkcs12.c: ditto.

ext/openssl/ossl_pkcs7.c: ditto.

ext/openssl/ossl_pkey_ec.c: ditto.

ext/openssl/ossl_x509.h: ditto.

ext/openssl/ossl_x509attr.c: ditto.

ext/openssl/ossl_x509crl.c: ditto.

ext/openssl/ossl_x509ext.c: ditto.

ext/openssl/ossl_x509req.c: ditto.

ext/openssl/ossl_x509revoked.c: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56018 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision ea5e22d1 - 08/26/2016 06:48 PM - nagachika (Tomoyuki Chikanaga)

backport fix memory leak from upstream.

https://github.com/ruby/openssl/compare/3a2840e80d275895523a526ce56e4f6e7b8f9cc4...1e30cd395b14ef46e04bdd9ab72f10067890b265

patches are provided by rhe (Kazuki Yamaguchi).

ext/openssl/ossl_config.c: fix memory leak.  [ruby-core:76922] [Bug #12680]

ext/openssl/ossl_ocsp.c: ditto.

ext/openssl/ossl_pkcs12.c: ditto.

ext/openssl/ossl_pkcs7.c: ditto.

ext/openssl/ossl_pkey_ec.c: ditto.

ext/openssl/ossl_x509.h: ditto.

ext/openssl/ossl_x509attr.c: ditto.

ext/openssl/ossl_x509crl.c: ditto.

ext/openssl/ossl_x509ext.c: ditto.

ext/openssl/ossl_x509req.c: ditto.

ext/openssl/ossl_x509revoked.c: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56018 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 18f287a36de45edcd39541015b445ee0b954e7b1 - 08/29/2016 08:36 PM - nagachika (Tomoyuki Chikanaga)

backport additional fix memory leak from openssl upstream.

https://github.com/ruby/openssl/commit/e76f076f093efb93dabf2cb042c527500f956061

patches are provided by rhe (Kazuki Yamaguchi).

ext/openssl/ossl_x509ext.c: additional fix memory leak.

[ruby-core:76922] [Bug #12680]

text/openssl/test_x509ext.rb: test for above.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56032 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 18f287a3 - 08/29/2016 08:36 PM - nagachika (Tomoyuki Chikanaga)

backport additional fix memory leak from openssl upstream.

https://github.com/ruby/openssl/commit/e76f076f093efb93dabf2cb042c527500f956061

patches are provided by rhe (Kazuki Yamaguchi).

ext/openssl/ossl_x509ext.c: additional fix memory leak.

[ruby-core:76922] [Bug #12680]

text/openssl/test_x509ext.rb: test for above.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56032 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/26/2016 06:50 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE

Thank you for your great work!

The patches are applied on ruby_2_3 branch at r56018.

#2 - 08/28/2016 09:53 AM - rhenium (Kazuki Yamaguchi)

nagachika-san:

I'm so sorry, the third one of the patches was broken. Could you backport this as well?

https://github.com/ruby/openssl/commit/e76f076f093efb93dabf2cb042c527500f956061
#3 - 08/29/2016 04:34 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED

#4 - 08/29/2016 08:37 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE

Files

patches-ruby-2-3.tar.gz 6.69 KB 08/16/2016 rhenium (Kazuki Yamaguchi)
